"use strict";
import { logoutKeycloak } from './authentication/script.js';//qui lo script si prende il token
import RequestToDomain from './authentication/requests-to-domain.js';
import Sensori from './sensori.js';
import Antifurto from "./antifurto.js";
import Scenari from "./scenari.js";
import Luci from './luci.js';
import Admin from './adminControls.js';


const logout = document.getElementById("button-logout");
logout.addEventListener('click', () => {
    logoutKeycloak();
});

// ask domain to know which service should be used
const domain = sessionStorage.getItem('domain')
// map all elements in servicesArray to be lower case
const servicesArray = (await RequestToDomain.getUsedServices(domain)).map(s => s.toLowerCase());// ["luci", "antifurto", ...]
const userPriviledges = await RequestToDomain.getUserPriviledges(domain);// "admin" or "user"

new Sensori();
const boolArray = [false, false, false];
let atLeastOneOfOurServices = false;
for (const service of servicesArray) {
    if (service === 'antifurto') {
        boolArray[0] = true;
        atLeastOneOfOurServices = true;
    }
    else if (service === 'scenari') {
        boolArray[1] = true;
        atLeastOneOfOurServices = true;
    }
    else if (service === 'luci') {
        boolArray[2] = true;
        atLeastOneOfOurServices = true;
    }
}
if (!atLeastOneOfOurServices) {
    document.getElementById('no-services').classList.remove('invisible');//TODO creare questo elemento
}

// launch each class
const antifurtobtn = document.getElementById("antifurto-btn");
if (boolArray[0])
    new Antifurto();
else {
    antifurtobtn.classList.add('invisible');
}


const scenariBtn = document.getElementById("scenari-btn");
if (boolArray[1])
    new Scenari();
else {
    scenariBtn.classList.add('invisible');
}

const luciBtn = document.getElementById("luci-btn");
if (boolArray[2])
    new Luci();
else {
    luciBtn.classList.add('invisible');
}

// if there is only one service, click the related button
// search if there's only one true in the boolArray
if (servicesArray.length === 1) {
    const btn = document.getElementById(`${servicesArray[0]}-btn`);
    btn.click();
    // btn.classList.add('invisible');
}

// if the user is an admin, show the admin panel
if (userPriviledges.toLowerCase() === 'admin')
    new Admin();